=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2009-02-10 04:30:21 +0000
+++ loggerhead/controllers/inventory_ui.py	2009-02-10 05:17:22 +0000
@@ -22,8 +22,9 @@
 import posixpath
 import urllib
 
-from paste.httpexceptions import HTTPServerError
+from paste.httpexceptions import HTTPNotFound
 
+from bzrlib import errors
 from bzrlib.revision import is_null as is_null_rev
 
 from loggerhead import util
@@ -35,8 +36,7 @@
 
 def dirname(path):
     if path is not None:
-        while path.endswith('/'):
-            path = path[:-1]
+        path = path.rstrip('/')
         path = urllib.quote(posixpath.dirname(path))
     return path
 
@@ -99,9 +99,8 @@
 
         try:
             rev_tree = history._branch.repository.revision_tree(revid)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise HTTPServerError('Could not fetch changes')
+        except errors.NoSuchRevision:
+            raise HTTPNotFound()
 
         file_id = kwargs.get('file_id', None)
         start_revid = kwargs.get('start_revid', None)

